package com.usky.demo.service.rocketmq;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.usky.common.core.util.JsonUtils;
import com.usky.demo.service.utils.TsdbUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * 中间处理消息转发
 */
@Service
@Repository
public class SimpleContext {
    @Autowired
    private TsdbUtils influxDBUtils;

    /**
     * 设备数据存influxdb时序数据库
     * @param
     */
    public void disposeMessageToDB(String message){
        Map<String, String> tags = new HashMap<>();
        Map<String, Object> fields = new HashMap<>();
        Map map_data = JsonUtils.fromJson(message,Map.class);
        String deviceId = map_data.get("device_id").toString();
        String productId = map_data.get("product_code").toString().toLowerCase();
        Long timestamp = Long.valueOf(map_data.get("timestamp").toString());
        String tableName = deviceId;

        Object tg = JSONObject.toJSONString(map_data.get("tags"));
        JSONObject tag = JSON.parseObject(tg.toString());
        for (String entry : tag.keySet()){
            tags.put(entry.toLowerCase(),tag.get(entry).toString());
        }

        Object met = JSONObject.toJSONString(map_data.get("metrics"));
        JSONObject metrics = JSON.parseObject(met.toString());
        for(String entry : metrics.keySet()){
            fields.put(entry.toLowerCase(),metrics.get(entry));
        }

        influxDBUtils.insertOne1(tableName,tags,fields,timestamp);
    }
}














